//+------------------------------------------------------------------+
//|                                                   e-Trailing.mq4 |
//--------------------------------------------------------------------
extern bool       ProfitTrailing        = true;  
extern string     Trailingstop_Settings = "";
extern int        TrailingStop          = 40;    
extern int        TrailingStep          = 1;     
extern bool       UseSound              = true;  
extern string     NameFileSound         = "cork_pop.wav";  
extern string 	   Breakeven_Settings    = "";
extern string     BE                    = "Break even settings";
extern bool       BreakEven             = true;
extern int        BreakEvenPips         = 40;


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() {
  for (int j=0; j<OrdersTotal(); j++) {
    if (OrderSelect(j, SELECT_BY_POS, MODE_TRADES)) {
      TrailingPositions();
    }
  }
}


void TrailingPositions() {
  double pBid, pAsk, pp;

  RefreshRates();
  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  double NewStop = 0 ;
  if (OrderType()==OP_BUY)
  {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if (BreakEven == true && OrderOpenPrice() + BreakEvenPips * pp < pBid && (OrderStopLoss() < OrderOpenPrice() || OrderStopLoss()==0)) NewStop = OrderOpenPrice() ;
    if (ProfitTrailing == true && pBid - OrderOpenPrice() > TrailingStop * pp && (OrderStopLoss() < pBid - (TrailingStop + TrailingStep -1)*pp || OrderStopLoss()==0)) NewStop = pBid - TrailingStop * pp ;
    if(NewStop != 0)
    {   
        ModifyStopLoss(NewStop);
        return;
    }
  }

  if (OrderType()==OP_SELL) {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (BreakEven == true && OrderOpenPrice() - BreakEvenPips * pp > pAsk && (OrderStopLoss() > OrderOpenPrice() || OrderStopLoss()==0)) NewStop = OrderOpenPrice() ;
    if (ProfitTrailing == true && OrderOpenPrice() - pAsk > TrailingStop * pp && (OrderStopLoss() > pAsk + (TrailingStop + TrailingStep -1) * pp || OrderStopLoss()==0)) NewStop = pAsk + TrailingStop * pp ;
    if(NewStop != 0)
    {   
        ModifyStopLoss(NewStop);
        return;
    }
  }
}
    
void ModifyStopLoss(double ldStopLoss) {
  bool fm;

  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE);
  if (fm && UseSound) PlaySound(NameFileSound);
  if (!fm)
  {
     int err;
     err=GetLastError();
     Print("Wheelbarrel trailing error (",err,")");
     return(0);
  }

}
//+------------------------------------------------------------------+



